﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Data;
using Infragistics.UltraChart.Resources.Appearance;

namespace Chart_Composite_ColumnLine
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();

            //AddDataToChart();
                
            ultraChart1.Data.ZeroAligned = true;
        }


        #region createData

        public void AddDataToChart()
        {
            NumericSeries seriesA = GetNumericSeriesBound("Series A", "Column A");
            NumericSeries seriesB = GetNumericSeriesBound("Series B", "Column B");
            NumericSeries seriesC = GetNumericSeriesBound("Series C", "Column C");
            NumericSeries seriesD = GetNumericSeriesBound("Series D", "Column D");
            NumericSeries seriesE = GetNumericSeriesBound("Series E", "Column E");
            NumericTimeSeries seriesLine = GetLineSeries();

            this.ultraChart1.CompositeChart.Series.Add(seriesA);
            this.ultraChart1.CompositeChart.Series.Add(seriesB);
            this.ultraChart1.CompositeChart.Series.Add(seriesC);
            this.ultraChart1.CompositeChart.Series.Add(seriesD);
            this.ultraChart1.CompositeChart.Series.Add(seriesE);
            this.ultraChart1.CompositeChart.Series.Add(seriesLine);

            ultraChart1.CompositeChart.ChartLayers[0].Series.Clear();
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(seriesA);
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(seriesB);
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(seriesC);
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(seriesD);
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(seriesE);
            ultraChart1.CompositeChart.ChartLayers[1].Series.Clear();
            ultraChart1.CompositeChart.ChartLayers[1].Series.Add(seriesLine);


            ultraChart1.CompositeChart.ChartAreas[0].Axes[1].RangeType = AxisRangeType.Custom;
            ultraChart1.CompositeChart.ChartAreas[0].Axes[1].RangeMin = 0;
            ultraChart1.CompositeChart.ChartAreas[0].Axes[1].RangeMax = 50;

            ultraChart1.CompositeChart.ChartAreas[1].Axes[1].RangeType = AxisRangeType.Custom;
            ultraChart1.CompositeChart.ChartAreas[1].Axes[1].RangeMin = 0;
            ultraChart1.CompositeChart.ChartAreas[1].Axes[1].RangeMax = 50;

        }

        public DataTable GetColumnData()
        {
            DataTable mydata = new DataTable();
            //Define the columns and their names
            mydata.Columns.Add("Series Labels", typeof(string));
            mydata.Columns.Add("Column A", typeof(int));
            mydata.Columns.Add("Column B", typeof(int));
            mydata.Columns.Add("Column C", typeof(int));
            mydata.Columns.Add("Column D", typeof(int));
            mydata.Columns.Add("Column E", typeof(int));
            //Add the rows of data
            mydata.Rows.Add(new Object[] { "Series A", 21, 14, 10, 43, 13 });
            mydata.Rows.Add(new Object[] { "Series B", 13, 36, 4, 16, 23 });
            mydata.Rows.Add(new Object[] { "Series C", 35, 28, 6, 23, 9 });
            return mydata;
        }

        public NumericTimeSeries GetLineSeries()
        {
            NumericTimeSeries series = new NumericTimeSeries();
            series.Points.Add(new NumericTimeDataPoint(DateTime.Now, 23, DateTime.Now.ToShortDateString(),false));
            series.Points.Add(new NumericTimeDataPoint(DateTime.Now.AddDays(1), 43, DateTime.Now.AddDays(1).ToShortDateString(),false));
            series.Points.Add(new NumericTimeDataPoint(DateTime.Now.AddDays(2), 13, DateTime.Now.AddDays(2).ToShortDateString(), false));
            series.Points.Add(new NumericTimeDataPoint(DateTime.Now.AddDays(3), 11, DateTime.Now.AddDays(3).ToShortDateString(), false));
            series.Points.Add(new NumericTimeDataPoint(DateTime.Now.AddDays(4), 37, DateTime.Now.AddDays(3).ToShortDateString(), false));
            series.PEs.Add(new PaintElement(Color.Red));
            return series;
        }

        public NumericSeries GetNumericSeriesBound(string serLabel, string valueColumn)
        {
            NumericSeries series = new NumericSeries();
            series.Label =  serLabel;
            // this code populates the series from an external data source
            DataTable table = GetColumnData();
            series.Data.DataSource = table;
            series.Data.LabelColumn = "Series Labels";
            series.Data.ValueColumn = valueColumn;
            return series;
        }
        #endregion createData



        public int ExtentLeft { get; set; }
        public int ExtentRight { get; set; }


        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {
            if (e.HasData)
            {
                if (e.Primitive is Box)
                {
                    double dobleExtent = ultraChart1.CompositeChart.ChartAreas[0].Axes[0].Extent + ((Box)e.Primitive).rect.Width * ultraChart1.CompositeChart.ChartLayers[0].Series[0].GetPoints().Count / 2;
                    ExtentLeft = (int)Math.Round(dobleExtent);
                    ExtentRight = ExtentLeft - ultraChart1.CompositeChart.ChartAreas[0].Axes[0].Extent;
                }
            }
        }

        private void ultraChart1_Load(object sender, EventArgs e)
        {
            ultraChart1.CompositeChart.ChartAreas[1].Axes[1].Extent = ExtentLeft;
            ultraChart1.CompositeChart.ChartAreas[1].Axes[2].Extent = ExtentRight;

        }

        public bool resizeFlag = false;
        private void ultraChart1_SizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Maximized)
            {
                ultraChart1.Refresh();
                resizeFlag = true;
            }
            if (resizeFlag || this.WindowState == FormWindowState.Normal)
            {
                ultraChart1.Refresh();
                resizeFlag = false;
            }

            //ultraChart1.Refresh();

            ultraChart1.CompositeChart.ChartAreas[1].Axes[1].Extent = ExtentLeft;
            ultraChart1.CompositeChart.ChartAreas[1].Axes[2].Extent = ExtentRight;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.Refresh();
        }
    }
}
